//==============================================================================
// VERSION 20051123 (c) Dipl. Inform. H. Gorski [www.HeikoGorski.de]
//==============================================================================
#ifndef _LFOUT_H_
#define _LFOUT_H_

#include <iostream>
#include <float.h>

//------------------------------------------------------------------------------
// Manipulationsklasse fr LONG DOUBLE - Variablen
// Da es ein automatisches CASTING (berfhren) von FLOAT und DOUBLE nach LONG
// DOUBLE gibt, funktioniert diese Klasse auch mit FLOAT und DOUBLE-Variablen
//------------------------------------------------------------------------------
class lfout
{
  //----------------------------------------------------------------------------
  // Diese Variablen knnen auerhalb der Klasse nicht direkt angesprochen
  // werden
  //----------------------------------------------------------------------------
  public:
  long double fValue;     // zur Formatierung bergebener Wert
  int         nNachkomma; // Anzahl der Nachkommastellen
  int         nVorkomma;  // Anzahl der Vorkommastellen

  //----------------------------------------------------------------------------
  // Diese Methoden (Funktionen) werden von Auerhalb verwendet, um die
  // Formatierung aufzurufen. Da die lfout (...) Methoden sehr klein sind,
  // werden sie hier implizit als INLINE-Funktionen (Makros) definiert.
  //----------------------------------------------------------------------------
  public:

  //----------------------------------------------------------------------------
  // Constructoren
  //----------------------------------------------------------------------------
  lfout (long double pValue);
  lfout (long double pValue, int pNachkomma);
  lfout (long double pValue, int pGesamtstellen, int pNachkomma);

  //----------------------------------------------------------------------------
  // berladen des OSTREAM-Operators << fr die Klasse LFOUT
  //----------------------------------------------------------------------------
  friend std::ostream& operator<< (std::ostream& pOutstream, const lfout& pLfout);

  //----------------------------------------------------------------------------
  // Setzen der Klassenvariablen
  //----------------------------------------------------------------------------
  lfout& set (long double pValue, int pGesamtstellen, int pNachkomma);
};

#endif
